// Name
// Student ID

// Store an array of all English words.
String[] words;

// Which mode are we currently in?
int mode = 0;
// How many modes are there in all?
int num_modes = 6;

// This regular expression is provided for you.  It determines
// whether a complete word contains the vowels a,e,i,o,u,y in order,
// with no other vowels in between.
//
// Here's a breakdown of the pattern:
//  * The initial "^" means that the pattern has to start at the start of
//    the line of text.
//  * The "[^aeiouy]" matches any letter that _isn't_ one of a, e, i, o, u, y.
//  * The "*" means to match any number of occurrences of something.  So
//    "[^aeiouy]*" is any run of consecutive consonants, possibly of length 0.
//  * The embedded "a", "e", "i", "o", "u" and "y" match precisely those letters.
//  * The final "$" forces the match to go right to the end of the line.
String aeiouy_pattern = "^[^aeiouy]*a[^aeiouy]*e[^aeiouy]*i[^aeiouy]*o[^aeiouy]*u[^aeiouy]*y[^aeiouy]*$";

void setup()
{
  size( 300, 600 );
  words = loadStrings( "sowpods.txt" );
  textSize( 24 );
}

// Is the character c any of the letters in the string s?
// A potentially handy helper function.
boolean isAnyOf( char c, String s )
{
  return s.indexOf( c ) != -1;
}

// This one is provided: find all the English words
// that end in "mt".
String[] getWords_0()
{
  String[] ret = {};

  for ( int idx = 0; idx < words.length; ++idx ) {
    if ( words[idx].endsWith( "mt" ) ) {
      ret = append( ret, words[idx] );
    }
  }

  return ret;
}

// Find all words that start with "he" and end with "he", not
// including the too-simple word "he" itself.
String[] getWords_1() 
{
  String[] ret = {};

  // TODO

  return ret;
}

// Find all words containing three "y"s but no other vowels.
String[] getWords_2() 
{
  String[] ret = {};

  // TODO
  // Suggestion: walk over all the characters in each word,
  // counting "y"s and counting other vowels.

  return ret;
}

// Find all words with six or more letters, in which all
// the letters are in strict alphabetical order (no
// repeated letters allowed!).  Example: "almost".
String[] getWords_3()
{
  String[] ret = {};

  // TODO
  // Hint: note that individual characters can be compared
  // using <, <=, >, >=, etc.  So in a string s, for example,
  // the letter at position idx comes alphabetically before
  // the letter at  position (idx+1) if this is true:
  //  s.charAt( idx ) < s.charAt( idx + 1 )

  return ret;
}

// Find all words in which the vowels "a", "e", "i", "o", 
// "u" and "y" appear _in that order_ in the word, with no
// other vowels.  Example: "facetiously".
String[] getWords_4()
{
  String[] ret = {};

  // TODO
  // Use the regular expression provided at the
  // top of the file.

  return ret;
}

// Find all words that contain at least five consecutive
// vowels, including "y".  That is, there must be a run of
// five vowels in the word without any consonants between them.
// Example: "queueing".
String[] getWords_5()
{
  String[] ret = {};

  // TODO
  // Use a regular expression of your own design.  Note that
  // the pattern "[aeiouy]" will recognize a single vowel, 
  // including "y".

  return ret;
}

// You don't need to change anything in the draw() function.
void draw()
{
  background( 50 );

  fill( 200, 200, 255 );
  text( "Mode " + mode, 10, 30 );

  fill( 255, 255, 255 );
  String[] result = {};

  if ( mode == 0 ) {
    result = getWords_0();
  } else if ( mode == 1 ) {
    result = getWords_1();
  } else if ( mode == 2 ) {
    result = getWords_2();
  } else if ( mode == 3 ) {
    result = getWords_3();
  } else if ( mode == 4 ) {
    result = getWords_4();
  } else if ( mode == 5 ) {
    result = getWords_5();
  }

  for ( int idx = 0; idx < result.length; ++idx ) {
    text( result[idx], 10, 80 + idx * 30 );
  }

  noLoop();
}

// Press a key to cycle through modes.
void keyPressed()
{
  mode = (mode + 1) % num_modes;
  loop();
}